# -*- coding: utf-8 -*-

meteo = open("Z:\gestion energie\meteo.txt",'r')
file = open("Z:\gestion energie\datahiver.txt",'r')
fileps = open("Z:\gestion energie\Panneausolaire.txt",'r')


Title = file.readline()
Lce = []
Llv = []
Lp = []
Lps = []

import math
from numpy import *
import numpy as np

Lvent = []
Lnebul = []
Lhumi = []

for line in meteo :
    line_token = line.split("	")
    Lvent.append(float(line_token[1]))
    Lnebul.append(float(line_token[2]))
    Lhumi.append(float(line_token[3]))

for line in file :
    line_token = line.split("	")
    Llv.append(float(line_token[2]))
file.close()
meteo.close()

for line in fileps :
    line_token = line.split("	")
    Lps.append(float(line_token[1]))
fileps.close()

file.close()

X = []
Y = []

for i in range (len(Llv)):
    Y.append(Lps[i])
    X.append([Lvent[i],Lnebul[i],Lhumi[i]])


from sklearn import tree


X7 = []
X7suite = []
Y7 = []
Y7suite=[]
L7 = int(len(X)*0.5)
for j in range (L7):
    X7.append(X[j])
    Y7.append(Y[j])
for j in range (L7,len(X)):
    X7suite.append(X[j])
    Y7suite.append(Y[j])


from sklearn import linear_model
import matplotlib.pyplot as plt

regression = linear_model.LinearRegression()
regression.fit(X7, Y7)
estimated=regression.predict(X7suite)

time =[]
for k in range (len(Y7suite)):
    z = 1435-(k*5)
    time.append(z)
    
print(len(Y7suite),len(estimated),len(time))
    
plt.figure
plt.ylabel("solar panel power (W)")
plt.xlabel("time (min)")
plt.plot(time,estimated,"m") #estimated solar panel power

plt.plot(time,Y7suite,"r") #real solar panel power
plt.show

S=0
for k in range(len(Llv)):
    S+=Llv[k]
print(S)

P=0
j=0
while P<S and j<len(Lps):
    P+=Lps[j]
    j+=1
print(j*5)

tmax_Llv=0
while Llv[tmax_Llv]==0:
    tmax_Llv+=1
print(tmax_Llv)#

max_Llv = 2192 #1er pic

tmax = 1435 #nbr de min dans une journée
 
tdeclenche = 0
while Lps[tdeclenche]<2100 and tdeclenche < len(Llv):
    tdeclenche+=1

print("Envoyer un message à ",tdeclenche*5,"minutes pour lancer le lave vaisselle")

Lavev = []
Solaire = []
q=len(Llv)-tmax_Llv
for n in range (q-1):
    Solaire.append(Lps[tdeclenche+n])
    Lavev.append(Llv[tmax_Llv+n])
    
print(len(Solaire),len(Lavev))

puis_reseau=[]
for h in range (len(Llv)):
    puis_reseau.append(0)


t = 0
m = len(Llv)-tmax_Llv
while t<m-1:
    puis_reseau[t]=Lavev[t]-Solaire[t]
    print(Lps[tdeclenche+t],Llv[tmax_Llv+t])
    t+=1
print ('"puissance puisée sur le réseau',puis_reseau)

somme =0
for f in range (len(puis_reseau)):
    if puis_reseau[f]>0:
        somme+=puis_reseau[f]
print("Il faut puiser sur le réseau",somme,"Watts")


#plt.plot(Lavev,"b--")
#plt.legend("usual energy consumption ")

#plt.plot(puis_reseau,"g-")
#plt.legend('energy consumption with solar pannels')

#plt.ylabel("Energy consumption (W) ")
#plt.xlabel("Time (min)")
#plt.show()
print("fini")